#include "stdafx.h"
#include "utiles.h"
#include <string.h>
#include <stdio.h>
#include <math.h>

char *formatoTelefono(char *pchOriginal, char *pchTransformado)
{
	char *pchPuntero;
	int intContador;
	int intTamano;

	intTamano = strlen(pchOriginal);

	pchPuntero = pchOriginal;
	if (*pchPuntero == '+')
	{
		pchPuntero++;
		intTamano--;
	}
	
	intContador = 0;
	while(intContador < intTamano)
	{
		if(*(pchPuntero+intContador + 1) != '\0')
			pchTransformado[intContador + 4] = *(pchPuntero + intContador + 1);
		pchTransformado[intContador + 1 + 4] = *(pchPuntero + intContador);
		intContador += 2;
	}

	if(intTamano % 2)
		pchTransformado[intContador - 2 + 4] = 'F';

	pchTransformado[intContador + 4] = '\0';
	memmove(pchTransformado,"0B91",4);

	return pchTransformado;
}


char *formatoMensaje(char *pchOriginal, char *pchTransformado)
{
	char pchTablaHex[]={'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'};
	unsigned char chrCaracter;
	int intContador;
	int intIndice;
	int intTamano;
	int intMascara;
	int intDesplaza;

	intTamano = strlen(pchOriginal);
	intMascara = 1;
	intContador = 0;
	intIndice = 2;
	strcpy(pchTransformado,"00");
	intDesplaza = 7;

	while(intContador < intTamano)
	{
		chrCaracter = ((*(pchOriginal + intContador + 1) & intMascara) << intDesplaza) + (*(pchOriginal + intContador) >> (7 - intDesplaza));
		pchTransformado[intIndice] = pchTablaHex[(chrCaracter & 0xF0) >> 4];
		intIndice++;
		pchTransformado[intIndice] = pchTablaHex[chrCaracter & 0x0F];
		intIndice++;
		intContador++;
		intMascara <<= 1;
		intMascara++ ;
		intDesplaza--;
		if(intDesplaza == -1)
		{
			intMascara = 1;
			intDesplaza = 7;
			intIndice -= 2;
		}
	}

	pchTransformado[intIndice] = '\0';

	chrCaracter=(char)intTamano;
	pchTransformado[0] = pchTablaHex[(chrCaracter & 0xF0) >> 4];
	pchTransformado[1] = pchTablaHex[chrCaracter & 0x0F];

	return pchTransformado;
}

void formatoEnvio(MENSAJE *mensaje)
{
	sprintf(mensaje->pchResultado,"001100%s0000AA%s",mensaje->pchTelefono,mensaje->pchTexto);
	mensaje->intLongitud=strlen(mensaje->pchResultado)/2-1;
}



char *decodificaMensaje(char *pchOriginal, char *pchTransformado)
{
	char pchLetras[5];
	unsigned char chrCaracter;
	int intTamano;
	int intContador;
	int intArrastre;
	int intDesplaza;
	int intIndice;
	int intMascara;

	intMascara = 128;
	intIndice = intContador = intArrastre = intDesplaza = 0;

	strcpy(pchLetras, "0x");
	strncat(pchLetras, pchOriginal + intIndice, 2);
	sscanf(pchLetras, "%x", &intTamano);

	intIndice += 2;

	while(intContador < intTamano)
	{
		strcpy(pchLetras, "0x");
		strncat(pchLetras, pchOriginal + intIndice, 2);
		sscanf(pchLetras, "%x", &chrCaracter);
		pchTransformado[intContador] = ((chrCaracter & ~intMascara) << intDesplaza) + intArrastre;
		intArrastre=(chrCaracter & intMascara) >> (7 - intDesplaza);
		intIndice += 2;
		intMascara >>= 1;
		intMascara += 128;
		intDesplaza++;
		if(intMascara == 255)
		{
			intContador++;
			pchTransformado[intContador] = chrCaracter >> 1;
			intMascara = 128;
			intDesplaza = intArrastre = 0;
		}
		++intContador;
	}

	pchTransformado[intContador] = '\0';

	return pchTransformado;
}

char *decodificaTelefono(char *pchOriginal, char *pchTransformado)
{
	int intContador=0;
	while(*(pchOriginal+intContador)!='\0')
	{
		*(pchTransformado+intContador)=*(pchOriginal+intContador+1);
		*(pchTransformado+intContador+1)=*(pchOriginal+intContador);
		intContador+=2;
	}
	*(pchTransformado+intContador-1)='\0';
	return pchTransformado;
}

char *decodificaFecha(char *pchOriginal, char *pchTransformado)
{
	pchTransformado[17]='\0';
	pchTransformado[16]=pchOriginal[0];
	pchTransformado[15]=pchOriginal[1];
	pchTransformado[14]='/';
	pchTransformado[13]=pchOriginal[2];
	pchTransformado[12]=pchOriginal[3];
	pchTransformado[11]='/';
	pchTransformado[10]=pchOriginal[4];
	pchTransformado[9]=pchOriginal[5];
	pchTransformado[8]=' ';
	pchTransformado[7]=pchOriginal[10];
	pchTransformado[6]=pchOriginal[11];
	pchTransformado[5]=':';
	pchTransformado[4]=pchOriginal[8];
	pchTransformado[3]=pchOriginal[9];
	pchTransformado[2]=':';
	pchTransformado[1]=pchOriginal[6];
	pchTransformado[0]=pchOriginal[7];

	return pchTransformado;
}

void interpretaCadena(char *pchOriginal,MENSAJE *mensaje)
{
	char *pchPuntero;
	char pchCadena[100];
	strtok(pchOriginal,"\r");
	strtok(NULL,"\r");
	pchPuntero=strtok(NULL,"\r");
	memmove(pchCadena,pchPuntero+23,12);
	pchCadena[12]='\0';
	decodificaTelefono(pchCadena, mensaje->pchTelefono);
	memmove(pchCadena,pchPuntero+39,12);
	pchCadena[12]='\0';
	decodificaFecha(pchCadena, mensaje->pchFecha);
	strcpy(pchCadena,pchPuntero+53);
	decodificaMensaje(pchCadena, mensaje->pchTexto);
}